#include <stdio.h>
#include <string.h>

#include "object.h"
#include "Attribute.h"
#include "LandscapeObject.h"
#include "LandscapeObject3D.h"
#include "EntityInstance.h"
#include "EntityCache.h"

CEntry::CEntry(CEntityInstance *eP, CEntry *nextP) 
{
	m_valueP = eP;
	m_nextP  = nextP;
}

int		CEntityCache::m_count = 0;
CEntry	*CEntityCache::m_table[0x40000] = {0};

void 
CEntityCache::put(CEntityInstance *eP) 
{
	int				index;
	const char		*idP, *P;
	CEntry			*entryP;

	index = 0;
	for (idP = P = eP->getId(); *P; ++P) {
		index <<= 1;
		index  ^= *P;
	}
	index       &= 0x3FFFF;

	for (entryP = m_table[index] ; entryP; entryP = entryP->m_nextP) {
		if (eP == entryP->m_valueP) {
			return;
	}	}	

	// Creates the new entry.
	m_table[index] = new CEntry(eP, m_table[index]);
	++m_count;
}

void 
CEntityCache::remove(CEntityInstance *eP) 
{
	int				index;
	CEntry			*entryP, *prevP;
	const char		*P, *idP;

	index = 0;
	for (idP = P = eP->getId(); *P; ++P) {
		index <<= 1;
		index  ^= *P;
	}
	index &= 0x3FFFF;


	prevP = 0;
	for (entryP = m_table[index]; entryP; prevP = entryP, entryP = entryP->m_nextP) {
		if (eP == entryP->m_valueP) {
			if (prevP) {
				prevP->m_nextP = entryP->m_nextP;
			} else {
				m_table[index] = entryP->m_nextP;
			}
			delete entryP;
			--m_count;
			return;
	}	}
	fprintf(stderr, "EntityCache: can't remove %s\n", idP);
}

CEntityInstance *
CEntityCache::get(const char *idP) 
{
	CEntry			*entryP;
	CEntityInstance	*eP;
	int				index;
	const char		*P;

	index = 0;
	for (P = idP; *P; ++P) {
		index <<= 1;
		index  ^= *P;
	}
	index &= 0x3FFFF;

	for (entryP = m_table[index] ; entryP; entryP = entryP->m_nextP) {
		eP = entryP->m_valueP;
		if (!strcmp(idP, eP->getId())) {
			return eP;
	}	}
	return 0;
}
