// Entities in a landscape 

class CRelationInstance;
class CRelationClass;
class CEntityClass;

#define NoLineno	0x7fffffff

#define CalledX		1
#define PolyX		2
#define SkippedX	4

#define VisitedX	(CalledX | PolyX | SkippedX)

#define ConstructorX 0x08
#define DestructorX  0x10
#define OverridesX	 0x20

class CEntityInstance : public CLandscapeObject3D /* extends LandscapeObject */{
public:
	
	/* keep tight control over the group flags so can draw changes at a low level */

	CRelationInstance	*m_srcRelListP;	// List of relations for which this entity is the source 
	CRelationInstance	*m_dstRelListP;	// List of relations for which this entity is the destination 
	CEntityInstance		*m_nextInClassP;
	CEntityInstance		*m_nextInOrderP;
	int					m_visited;
	const char			*m_fullpathP;
	int					m_lineno;
	
 	CEntityInstance(CEntityClass *parentClassP, const char *idP); 
	virtual void putAttribute(const char *idP, const char *valueP);
	CEntityClass 		*getEntityClass(void) const; 
	const char 			*getClassLabel(void);
	CRelationInstance 	*getSrcRelList(void) const;
	CRelationInstance	*getDstRelList(void) const;
	CEntityInstance		*getParent(void) const;

	CRelationInstance *getRelationTo(CRelationClass *rcP, CEntityInstance *dstP); 
	int				buildPath(char **bufferPP, int load);
};
